'Egy BASIC mintaprogram a PICPLC8 panelere.   16F1937 proci.
'      Futfny
'A program egy 8 elemes "tmbbl" szedi ki szp sorban az adatokat.
'Aztn a 8 bites adatot kikldi a relkre 
'A proci beptett rajelgenertort hasznlom - INTOSC - s kdvdelem - CP - kikapcsolva
'A PLL rajel ngyszerez, s az alacsonyfeszltsg programozs - LVP - kikapcsolva. 
#CONFIG             
    __config _CONFIG1, _FOSC_INTOSC & _CP_OFF
    __config _CONFIG2, _PLLEN_OFF & _LVP_OFF 
#endCONFIG

    OSCCON = %01101010   ' Belltom 4 megra a bels rajelet

' Akr 14 lb hasznlhat analg bemenetnek, de most minden lbat digitlis portnak akarunk.
   ANSELA = %00001111    ' porta 0-3 analg, a 4-7 digitlis
   ANSELB = %00000000    ' portb mind digitlis
   ANSELD = %00000000    ' portd mind digitlis
   ANSELE = %00000000    ' porte mind digitlis

   TRISC = %00111100	' A PORTC 2-5 input, a PORTC 0-1 s 6-7 output
   TRISA = %00000000	' A PORTA 0-7  output
  
	DEFINE LCD_DREG 	PORTD	' Az LCD adatbitek a D porton
	DEFINE LCD_DBIT 	0	' Az els bit az RD0
	DEFINE LCD_RSREG 	PORTD	' A register select bit a D porton,
	DEFINE LCD_RSBIT 	4	' az RD4 port
	DEFINE LCD_EREG 	PORTD	' Az enable bit a D porton,
	DEFINE LCD_EBIT 	5	' az RD5 portra van kiosztva
	DEFINE LCD_BITS 	4	' a 4 bites zemmodot valasztjuk
	DEFINE LCD_LINES 	2	' 2 soros az LCD


	TRISB = %00000000	' A PORTB0-7 output
	TRISE = %00000000	' A PORTE.0 PORTE.1 s PORTE.2 output
    OPTION_REG = $55    ' Set TMR0 configuration and enable PORTB pullups

		' Helyet foglalunk a vltozoknak a mikrokontroller RAM-jaban   
    
    index VAR byte
    lepes VAR byte
    ledek VAR byte
    adat VAR byte[16] 'Csinlunk egy 16 elemes adat sort, tmbt

    adat[1]   = %10000000   ' Az adattmb
    adat[2]   = %01000000   ' bitenknt megadjuk, melyik LED gyjtson majd be
    adat[3]   = %00100000
    adat[4]   = %00010000
    adat[5]   = %00001000    
    adat[6]   = %00000100
    adat[7]   = %00000010
    adat[8]   = %00000001  
    adat[9]   = %00000011
    adat[10]  = %00000111
    adat[11]  = %00001111    
    adat[12]  = %00011111
    adat[13]  = %00111111
    adat[14]  = %01111111
    adat[15]  = %11111111
    adat[16]  = %00000000            
    
    STROBE var PORTB.5		' A 74HC4094 kimeneti beiro jele a PORTB.5,
	CLK var PORTB.7			' az orajele a PORTB.7,
	DAT var PORTB.6 		' az adat bemenete a PORTB.6-ra van kiosztva.    
    
    PORTC.1 = 0             ' LCD httrvilgts bekapcsols
    
main:   
   
   for index = 1 to 16     'Ez egy "ciklus". Egyms utn beolvassuk a 8 elemet
        ledek = adat[index]  'A "ledek" bjtba rakjuk az pp soron lv adat tmb tagot
                
        pause 2000  ' 2 msodpercig tart ez az llapot. (2000 millisec)
        Toggle PORTA.4			' Az RA4 porton vezerelt LED ki/bekapcsolgatsa
        
        GOSUB relek  ' Kirakjuk a relkre 
        
        LCDOUT $fe,$80,"Relek: ",#ledek.7,#ledek.6,#ledek.5,#ledek.4,#ledek.3,#ledek.2,#ledek.1,#ledek.0 ' irs az els sorba
        LCDOUT $fe,$C0,"Lepes : ", dec2 index  'Kt szmjegyen decimlis

        
    next index      ' s jhet a kvetkez...
 
    goto main       ' Ha lefutott a ciklus, ugrs vissza az elejre!
    

    relek:
       SHIFTOUT   DAT,CLK,0,[ledek]   'a 74HC4094-be lptetjk a rel vezrl adatot

	   HIGH STROBE			' Hoga a beleptetett adatokat a kimenetre kapcsoljuk, 
	   Pause 1				' a "Strobe"-ra egy beiro jelet kell adnunk.
	   LOW STROBE 			' A 4094 kimeneten megjelennek a beleptetett adatok.
    return
    
    END				' Itt a progi vege. 
